<template>
    <div>
        <div class="card-body">

            <input type="hidden" name="restaurant_id" value/>

            <itemDetailForm v-on:data_updated="updatedItemDetail"/>

            <variations v-on:variations_updated="updatedVariations"/>
            <button class="btn btn-success btn-icon-split float-right my-4"
                    @click.prevent="storeFoodItem">
                <span class="text font-weight-bold">Submit Details</span>
                <span class="icon text-white">
            <i class="fas fa-arrow-right"></i>
          </span>
            </button>
        </div>
    </div>
</template>

<script>
    import itemDetailForm from "./itemDetail";
    import variations from "./variations";

    export default {
        name: "FoodItemForm",
        components: {
            itemDetailForm,
            variations
        },
        data() {
            return {
                form_data: {
                    name: '',
                    price: '',
                    description: '',
                    food_type: 0,
                    menu_section_id: 0,
                    restaurant_id: new URL(window.location.href).searchParams.get("restaurant"),
                },
                image: '',
                mandatoryBoxes: [],
                optionalBoxes: [],
            }
        },
        methods: {
            updatedItemDetail(data) {
                this.form_data = data.form_data;
                this.image = data.image;
            },
            updatedVariations(data) {
                this.mandatoryBoxes = data.mandatoryBoxes;
                this.optionalBoxes = data.optionalBoxes;
            },
            storeFoodItem() {

                let formData = new FormData();

                formData.append('image', this.image);
                formData.set('form_data', JSON.stringify(this.form_data));
                formData.set('mandatoryVariations', JSON.stringify(this.mandatoryBoxes));
                axios({
                    method: 'post',
                    url: '/admin/food-item',
                    data: formData,
                    config: {headers: {'Content-Type': 'multipart/form-data'}}
                })
                    .then(function (response) {
                        if (!response.data.error)
                            location.href = '/admin/food-item/';
                    })
                    .catch(function (response) {
                        //handle error
                        console.log(response);
                    });


            }
        }
    };
</script>

<style>
</style>
